#!/usr/bin/perl -T
# $Id: main.cgi,v 1.35 2023/10/27 08:24:32 sqko Exp $
############################################################
############################################################
###                                                      ###
###   Originally designed by Soeren Koch                 ###
###                                                      ###
###   Impelemented by Soeren Koch                        ###
###                                                      ###
###   Copyright by Soeren Koch January 2011              ###
###                                                      ###
############################################################
############################################################
use strict;
use warnings;
use RFC::Main;
use RFC::RFCCGI qw(:cgi :html);
use RFC::Header;
use RFC::Furnace;
use SocketClient;
use CGI qw(:standard :netscape);
use Sys::Hostname;
use SemaforeFile;

my $hostname = hostname;
my $pwdhost = get_cv('passwds','passwd_server');
my $name = &get_cv('global','server_name');
$name = hostname unless ($name);
my ($u,$p) = &RFC::RFCCGI::get_id();
my $isadmin = 0;
my $local_admin = 0;
if (!defined(param))
{
    &print_header("Please log in to the $name");
    print '<center>';
    RFC::RFCCGI::login();
    print '</center>';
    &print_end('../RFCfurnace/manual.pdf');
}
else
{
    my $uid = login_ok();
    $isadmin = &is_admin();
    if ($uid)
    { 
	$uid = &RFC::Main::passwd_client('pwdstatus',&get_id()) if ($hostname eq $pwdhost);
	&print_header($name);
	print '<script src="/celltest/RFCcontrol.js"></script>',"\n";
        print '<link rel="stylesheet" type="text/css" href="/RFCfurnace/Furnace.css" />',"\n";
	top_nav_bar_start();
	if ($isadmin)
	{
	    $local_admin = 1;
	    top_nav_bar_button('../celltest/confmanage.cgi','','','Global configuration','s0');
	    if ($hostname eq $pwdhost)
	    {
		top_nav_bar_button('../celltest/usermanage.cgi','','','User management','s1');
	    }
	    else
	    {
		top_no_button;
	    }
	}
	else
	{
	    my $id = &RFC::Main::get_cv('global','authorisation_change_allow_start');
	    $local_admin = &RFC::Main::passwd_client('safety_auth',$u,$id,'skiplabtech') if ($id);
	    if ($hostname eq $pwdhost)
	    {
		top_nav_bar_button('task.cgi','','','Manage safty clearances','s3');
	    }
	    else
	    {
		top_no_button;
	    }
	    top_no_button;
	}
	top_no_button();
	tab_newrow();
	js_back();
	top_js_return('#006600','white');
	top_no_button();
	if ($hostname eq $pwdhost)
	{
	    &top_nav_bar_button('../celltest/changepwd.cgi','','','Change password','s7');
	}
	else
	{
	    # Todo: insert correct 'profile.cgi' call
	    top_no_button;
	}
#	&top_nav_bar_button('../celltest/about.cgi','','','About','s8');
	top_no_button;
	## Specproc for derect access to labysstem, remoove if no labsystem ####
	## top_no_button();
	my $server = get_cv('passwds','passwd_server');
	if (param('action'))
	{
	    &top_nav_bar_button('main.cgi','','','To furnace groups','s6');
	}
	else
	{
	    if (CGI::https())
	    {
		&top_nav_bar_button('https://'.$server.'/cgi-bin/front/main.cgi','','','To main menu','s4');
	    }
	    else
	    {
		&top_nav_bar_button('http://'.$server.'/cgi-bin/front/main.cgi','','','To main menu','s4');
	    }
	}
	## End specproc
	&end_top_bar;
        if ($uid =~ /RESET/)
        {
            print center(h1({-class=>'Alert'},"You must change your password!"));
        }
	elsif ($uid =~ /EXPIRE/)
	{
	    print center(h1({-class=>'Alert'},"Your password has expired, Please change password"));
	}
        else
        {
	    if (param('action') && param('action') eq 'select_server')
	    {
		&select_server;
	    }
	    else
	    {
		&main_page;
	    }
	}
	&print_end('../RFCfurnace/manual.pdf');
    }
    else 
    {
	&not_auth;
    }
}
    
exit;


sub select_server
{
    my $allow_start = &RFC::Main::get_cv('global','allow_start');
    my @list = ();
    my $str = get_cv('celltest','rigs');
    $str = '' unless defined($str);
    my @l = split(/\s*\,\s*/,$str);
    print '<center>';
    if ($allow_start && $allow_start =~ /no/i)
    {
	print p();
	print h1({-class=>'Alert'},'Furnace start disabled!');
    }
    print '<table class="main_select">';
    print '<tr><td class="heading" colspan='.scalar(@l).'>';
    print "<center><h1>Select furnace:</h1></center>";
    print '</td></tr><tr>';
    my $count = 1;
    foreach my $r (sort {$a <=> $b} @l)
    {
	if ($count > 5)
	{
	    $count = 1;
	    print "</tr><tr>\n";
	}
	push @list,$r;
#	my $temp = &get_atemp($r);
	print '<td>';
	print start_form(-action=>'/cgi-bin/RFCfurnace/furnace.cgi');
	&print_hidden();
	print hidden(-name=>'rig',-value=>$r,-force=>1);
#	print "<button type=submit class=main4 id=$r> Furnace $r ($temp) </button>";
	print "<button type=submit class=main4 id=$r> Furnace $r </button>";
	print end_form();
	print '</td>';
	$count++
    }
    print '</table>';
#    print '<table class="main_select">';
#    print '<tr><td colspan='.scalar(@l).' class="heading">';
#    print "<center><h1>Data on all furnace runs</h1></center>";
#    print '</td></tr>';
#    foreach my $r (sort {$a <=> $b} (@l))
#    {
#	next unless ($r && $r =~ /\d/);
#	print '<td>';
#	print start_form(-action=>'/cgi-bin/RFCfurnace/search.cgi');
#	&print_hidden();
#	print hidden(-name=>'rig',-value=>$r,-force=>1);
#	print submit(-name=>'dummy',-value=>'Furnace '.$r,-class=>'main0');
#	print end_form();
#	print '</td>';
#    }
#    print '</table>';
    print '</center>';
    &print_js(@list) if (@list);
}

sub main_page
{
    my $is_cache = 0;
    my $save_cache = 0;
    my %cache = ();
    my $file = '/tmp/RFCFurnacecache.txt';
    my $conf = SemaforeFile->new($file);
    $conf->lock_sh();
    if ($conf->exist)
    {
        $is_cache = 1;
        my $mtime = $conf->mtime();
        $is_cache = 0 if ($mtime + 3600 < time);
        $is_cache = 0 if (param('reload'));
    }
    if ($is_cache)
    {
        foreach my $l ($conf->readlines())
        {
            next unless ($l);
            chomp $l;
            my ($k,$d) = split(/\s*\#\s*/,$l);
            $cache{$k} = $d;
        }
    }
    $conf->lock_un();

    print <<END unless (param('target_rig'));

<script>

function get_run_status(server,id)
{
    var str = '&action=get_run_status&elementid='+id;
    run_ajax('https://'+server+'/cgi-bin/RFCfurnace/ajax.cgi',str,set_run_status_res);
}

function set_run_status_res(res)
{
    var arr = res.split('\\n');
    if (arr[0] == 'OK')
    {
	var e = document.getElementById(arr[2]+'_status');
	e.name = arr[1];
	if (e.name == 'no')
	{
	    e.style.backgroundColor = 'LightCoral';
	    e.value = 'Furnace start disabled';
	}
	else
	{
	    e.style.backgroundColor = 'LightGreen';
	    e.value = 'Furnace start enabled';
	}
	return true;
    }
    alert(res);
}

</script>

END

    my @riglist = ();
    print '<center>';
    my @list = ();
    my @listservers = ();
    my $listserver = get_cv('servers','listserver');
    if ($listserver)
    {
        chomp $listserver;
        unless ($is_cache && $cache{'servers'})
        {
            my $str= &RFC::Main::report_client($listserver,'servers');
            my @l = split(/\t/,$str) if ($str && $str !~ /ERROR/);
            foreach (@l)
            {
                if (/([\w\.\-]+)/)
                {
                    push @list,$1;
                }
            }
            $cache{'servers'} = join(',',@list);
            $save_cache = 1;
        }
        @list = split(/\s*\,\s*/,$cache{'servers'});
        unless ($is_cache && $cache{'listservers'})
        {
            my $str= &RFC::Main::report_client($listserver,'list_servers');
            my @l = split(/\t/,$str) if ($str && $str !~ /ERROR/);
            foreach (@l)
            {
                if (/([\w\.\-]+)/)
                {
                    push @listservers,$1;
                }
            }
            $cache{'listservers'} = join(',',@listservers);
            $save_cache = 1;
        }
        @listservers = split(/\s*\,\s*/,$cache{'listservers'});
    }
    if (@listservers && @listservers > 1)
    {
	print h1("Avaliable listservers");
	print '<table class="main_select"><tr>';
	foreach my $s (sort @listservers)
	{
	    print '<td>';
	    if (CGI::https())
	    {
		print start_form(-action=>'https://'.$s.'/cgi-bin/RFCfurnace/main.cgi');
	    }
	    else
	    {
		print start_form(-action=>'http://'.$s.'/cgi-bin/RFCfurnace/main.cgi');
	    }
	    my $ss = 'http://'.$s;
	    $ss = 'https://'.$s if (CGI::https());
	    &print_hidden();
	    print submit(-name=>'dummy',-value=>$s,-class=>'main1',-id=>'list_'.$s);
	    print end_form();
	    print '</td>';
		print <<END;
<script>
    get_server_name('$ss',function(res){if (!res) {return false;};document.getElementById('list_'+'$s').value = res});
</script>
END

	}
	print '</tr></table>';
    }
    if (@list)
    {
	print p('&nbsp;');
	print h1("Select furnace group");
	print '<table class="main_select">',"\n";
	foreach my $s (sort @list)
	{
	    print '<tr>';
            unless ($is_cache && $cache{$s.'_active_rigs'})
            {
                my $str = &RFC::Main::report_client($s,'active_rigs');
                $str = '' unless defined($str);
                $cache{$s.'_active_rigs'} = $str;
                $save_cache = 1;
            }
            my $str = $cache{$s.'_active_rigs'};
	    my $ss = 'http://'.$s;
	    $ss = 'https://'.$s if (CGI::https());
	    my @l = ();
	    @l = split(/\t/,$str) if ($str);
	    print '<td>';
	    if (CGI::https())
	    {
		print start_form(-action=>'https://'.$s.'/cgi-bin/RFCfurnace/main.cgi');
	    }
	    else
	    {
		print start_form(-action=>'http://'.$s.'/cgi-bin/RFCfurnace/main.cgi');
	    }
	    &action('select_server');
	    &print_hidden();
	    print submit(-name=>'dummy',-value=>$s,-class=>'main2',-id=>$s);
	    print end_form();
	    print '</td>';
	    print '<td>';
	    print button(-class=>'change_furnace_start',-id=>$s.'_status',-name=>'',-value=>'Getting status...',-onclick=>"set_run_status('$s',this)") if ($local_admin);
	    print '</td>';
	    print <<END;

<script>
    get_server_name('$ss',function(res){if (!res) {return false;};document.getElementById('$s').value = res});	    
    get_run_status('$s','$s');
</script>
END

	    if (@l && $l[0] =~ /error/i)
	    {
		print "<th colspan=12>Error: Could not contact server '$s'</th>";
		&errorlog($l[0]);
		next;
	    }
	    print '</tr>',"\n";
	    foreach my $f (@l)
	    {
		if (CGI::https())
		{
		    print start_form(-action=>'https://'.$s.'/cgi-bin/RFCfurnace/show_old.cgi', -name=>'to_furnace_'.$f);
		}
		else
		{
		    print start_form(-action=>'http://'.$s.'/cgi-bin/RFCfurnace/show_old.cgi' , -name=>'to_furnace_'.$f);
		}
		print hidden(-name=>'rig',-value=>$f,-force=>1);
		print hidden(-name=>'testnr',-value=>param('target_test'),-force=>1);
		&print_hidden();
		print end_form();
	    }
	}
    }
    else
    {
        print h1({-class=>'Alert'},"Error: Could not get server list from from '$listserver', using local list only");
        print '<table class="main_select">';
        print '<tr><td colspan=10 class="heading">';
        print "Select furnace:";
        print '</td></tr><tr>';
        my $str = get_cv('celltest','rigs');
        $str = '' unless defined($str);
        my @l = split(/\s*\,\s*/,$str);
        foreach my $r (sort {$a <=> $b} @l)
        {
	    push @riglist,$r;
	    print '<td>';
	    print start_form(-action=>'furnace.cgi');
	    &print_hidden();
	    print hidden(-name=>'rig',-value=>$r,-force=>1);
	    print submit(-name=>'dummy',-value=>'Furnace '.$r,-class=>'main4',-id=>$r);
	    print end_form();
	    print '</td>';
	    print start_form(-action=>'show_old.cgi', -name=>'to_furnace_'.$r);
	    print hidden(-name=>'rig',-value=>$r,-force=>1);
	    print hidden(-name=>'testnr',-value=>param('target_test'),-force=>1);
	    &print_hidden();
	    print end_form();
        }
    }
    print '</table>';
    print '</center>';
    &print_js(@riglist) if (@riglist);
    eval {
        if (!$is_cache && %cache || $save_cache)
        {
            $conf->lock_ex();
            $conf->writeline('');
            foreach my $key (keys %cache)
            {
                $conf->append($key.'#'.$cache{$key});
            }
            chmod 0666,$file;
            $conf->lock_un();
        }
    };
    if ($@)
    {
        warn $@;
    }
    my $logaddr = get_cv('global','remote_equipment_database');
    $logaddr = '' unless ($logaddr);
    my $target = '';
    if (param('target_rig'))
    {
        my $t = param('target_rig');
        $target = <<END;
document.addEventListener('DOMContentLoaded', function() {
   document.to_furnace_$t.submit();
}, false);

END
    }
    print <<END;

<script>

var active_element;
var active_server;
var adr = '$logaddr';

function set_run_status(server,e)
{
    if (active_element != null)
    {
	return false;
    }
    active_server = server;
    active_element = e;
    var status = 'no';
    if (e.name == 'no')
    {
	status = 'yes';
    }
    var str = '&action=set_run_status&value='+status;
    run_ajax('https://'+server+'/cgi-bin/RFCfurnace/ajax.cgi',str,set_status_result);
}

function set_status_result(res)
{
    active_element = null;
    var arr = res.split('\\n');
    if (arr[0] == 'OK')
    {
	if (adr != '')
	{
	    var str = 'Changed allow furnace runs to "'+arr[1]+'"';
	    var query = '&action=new_maint_log&type=Userlog'+'&equipid='+arr[2]+'&description='+str;
	    run_ajax(adr,query,set_log_ok);
	}
	get_run_status(active_server,active_server);
	return true;
    }
    alert(res);
}

function set_log_ok(res)
{
    if (res == 'OK')
    {
	return true;
    }
    alert(res);
}

$target

</script>

END

}



sub print_js(@)
{
    my @fnlist = ();
    foreach my $x (@_)
    {
	push @fnlist,"   run_ajax('ajax_furnace.cgi','&action=status&furnace=$x',function(res){set_status($x,res)});";
    }
    my $str = join("\n",@fnlist);
    print <<END;

<script>


function check_all()
{
$str   
    setTimeout(check_all,60000);
}

function set_status(id,status)
{
    var e = document.getElementById(id);
    var val = e.innerHTML;
    var reg = /<br>/;
    if (reg.test(val))
    {
	var info = val.split('<br>');
	e.innerHTML = info[0] + '<br>'+status;
    }
    else
    {
	e.innerHTML = e.innerHTML + '<br>'+status;
    }
    if (status == 'Running')
    {	
	e.className = 'main6';
    }
    else if(status == 'Free')
    {
	e.className = 'main4';
    }
    else
    {
	e.className = 'main0';
    }
}

check_all();
</script>
END
}



sub get_atemp($)
{
    my $r = shift;
    my $temp = ' - ';
    eval {
	my $rig = RFC::Rig->new($r);
	my $furnace = RFC::Furnace->new($rig);
	$temp = sprintf("%.0f",$furnace->get_atemp()).' C';
    };
    return $temp;
}
