#!/usr/bin/perl -T
#$Id: pick_elements.cgi,v 1.15 2022/11/25 07:35:30 sqko Exp $
use strict;
use warnings;
use RFC::RFCCGI qw(:cgi :html);
use RFC::Header;
use RFC::Furnace;
use CGI qw(:standard :netscape);
my $elements = param('elements');
my $furnace = param('furnace');
my $rig = param('rig');
$rig = $furnace unless ($rig);
print_header('Periodic table of Elements');
print '<link rel="stylesheet" type="text/css" href="/RFCfurnace/PTE.css" />',"\n";

my @list = RFC::Furnace::get_element_data();
shift @list; ## Remove 'element' 0;
foreach my $n (split(/[\s\,]+/,$elements))
{
    foreach my $e (@list)
    {
	next unless ($$e{'short'} eq $n);
	$$e{'test'} = 1;
    }
}
my $modify = 1;
$modify = 0 if (param('readonly'));
my $back = 0;
$back = 1 if (param('back'));
print '<center><table class=status border=0 cellspacing=10 cellpadding=10>';
my $period = 0;
my $group = 0;
foreach (@list)
{
    next unless ($$_{'egroup'} < 20);
    if ($$_{'period'} != $period)
    {
	print '</tr><tr>';
	$period = $$_{'period'};
	$group = 0;
    }
    $group++;
    while ($group < $$_{'egroup'})
    {
	$group++;
	print '<td></td>';
    }
    if ($$_{'test'})
    {
	print '<td class="selected" id="fld_'.$$_{'Z'}.'">';
    }
    else
    {
	print '<td class="'.$$_{'eclass'}.'" id="fld_'.$$_{'Z'}.'">';
    }
    print button(-id=>'btn_'.$$_{'Z'},-name=>$$_{'short'},-label=>$$_{'short'},-class=>$$_{'eclass'},-onclick=>"javascript:alert('$$_{'name'}, Atomic number: $$_{'Z'}\\n$$_{'eclass'}\\n$$_{'comments'}')");
    print '<br>';
    if ($modify)
    {
	print checkbox(-id=>'chk_'.$$_{'Z'},-name=>'element_'.$$_{'Z'},-label=>'',-checked=>$$_{'test'},-force=>'1',-onchange=>"set_element($$_{'Z'})");
	
    }
    else
    {
	print checkbox(-id=>'chk_'.$$_{'Z'},-name=>'element_'.$$_{'Z'},-label=>'',-checked=>$$_{'test'},-force=>'1',-disabled=>1);
    }
    print '</td>';
    print "\n";
}
$period = 0;
$group = 0;
print '</tr><tr><td></td>';
foreach (@list)
{
    next unless ($$_{'egroup'} > 20);
    $$_{'egroup'} -= 20;
    if ($$_{'period'} != $period)
    {
	print '</tr><tr>';
	$period = $$_{'period'};
	$group = 0;
    }
    $group++;
    while ($group < $$_{'egroup'})
    {
	$group++;
	print '<td></td>';
    }
    if ($$_{'test'})
    {
	print '<td class="selected" id="fld_'.$$_{'Z'}.'">';
    }
    else
    {
	print '<td class="'.$$_{'eclass'}.'" id="fld_'.$$_{'Z'}.'">';
    }
    print button(-id=>'btn_'.$$_{'Z'},-name=>$$_{'short'},-label=>$$_{'short'},-class=>$$_{'eclass'},-onclick=>"javascript:alert('$$_{'name'}, Atomic number: $$_{'Z'}\\n$$_{'eclass'}\\n$$_{'comments'}')");
    print '<br>';
    if ($modify)
    {
	print checkbox(-id=>'chk_'.$$_{'Z'},-name=>'element_'.$$_{'Z'},-label=>'',-checked=>$$_{'test'},-force=>'1',-onchange=>"set_element($$_{'Z'})");
    }
    else
    {
	print checkbox(-id=>'chk_'.$$_{'Z'},-name=>'element_'.$$_{'Z'},-label=>'',-checked=>$$_{'test'},-force=>'1',-disabled=>1);
    }
    print '</td>';
    print "\n";
}
print '</table>';
print p();
if($back)
{
    print button(-name=>'Back',-class=>'s3',-style=>'width:100px;',-onclick=>'history.back()');
}
elsif (param('readonly'))
{
    print button(-name=>'Close',-class=>'s3',-style=>'width:100px;',-onclick=>'window.close()');
}
else
{
    print button(-name=>'Close',-class=>'s3',-style=>'width:100px;',-onclick=>'my_close()');
}
print '</center>';


my @array = ('var ecls = new Array;');
foreach (@list)
{
    push @array,'ecls['.$$_{'Z'}.'] = "'.$$_{'eclass'}.'";';
}
my $str = join("\n",@array);
my $equipid = 0;
if ($furnace)
{
    $str .= "\nvar furnace = true\n";
}
else
{
    $str .= "\nvar furnace = false\n";
}

$rig = 0 if (param('noinit'));

if ($rig)
{
    my $r = RFC::Rig->new($rig);
    $equipid = $r->get_cv('main','equipmentid');
}
my $ajax = &RFC::Main::get_cv('global','remote_equipment_database');
my $get_remote = 'true';
$get_remote = 'false' unless ($ajax);

print <<END;


<script>

$str

var get_remote = $get_remote;

function get_allowed()
{
    if (get_remote)
    {
	run_ajax('$ajax','&action=list_pte_equipment&id='+$equipid,set_allowed);
    }
}


function set_allowed(res)
{
    var arr = res.split("\\n");
    if (arr[0] == "OK")
    {
        arr.shift();
        arr.shift();
	var elements = new Array;
	for (var x = 0; x < arr.length;x++)
	{
	    var a = arr[x].split("\\t");
	    elements.push(a[0]);
	}
	for (var x = 0; x < elements.length;x++)
	{
	    var Z = elements[x];
            if (e != null && e != '')
            {
		var e = document.getElementById('fld_'+Z);
		// Todo: apply correct css to elements 
		    // e.style.borderColor = "#1068b5";
		e.className += " allowed";
	    }
	}
    }
    else
    {
	alert(res);
    }
}

function my_close()
{
    if (furnace)
    {
	opener.document.set_elements.submit();
    }
    window.close();
}

function set_element(id)
{
    var node = document.getElementById('fld_'+id);
    var btn = document.getElementById('btn_'+id);
    var chk = document.getElementById('chk_'+id);
    if (node.classList.contains("allowed") ) 
    	{
    		var s = " allowed";
    	}
    else 
    {
    	var s = "";
    }
    if (chk.checked)
    {
	node.classList.remove("allowed");
	node.classList.remove(ecls[id]);
	node.class += "selected";
	node.className += "selected";
	node.class += s;
	node.className += s;
	
	//node.setAttribute("class","selected");
	//node.setAttribute("className","selected");	
    }
    else
    {
	node.classList.remove("selected");
	node.classList.remove("allowed");
	node.class +=  ecls[id];
	node.className +=  ecls[id];
	node.class += s;
	node.className += s;

	//node.setAttribute("class",ecls[id]);
	//node.setAttribute("className",ecls[id]);
    }
    save_elements();
}


function save_elements()
{
    var arr = new Array();
    var x;
    for (x = 1; x < 119; x++)
    {
	var chk = document.getElementById('chk_'+x);
	var btn = document.getElementById('btn_'+x);
	if (chk.checked)
	{
	    arr.push(btn.name);
	}
    }
    var str = arr.join(',');
    if (furnace)
    {
	opener.document.getElementById('f_elements').value = str;
    }
    else
    {
	opener.document.getElementById('comp').value = str;
	opener.element_ok = true;
    }
}

get_allowed();

</script>

END
